SystemOrganization addCategory: #GODSocialNetIO!

GODData subclass: #SNETSocialNetPost
	instanceVariableNames: 'hashtags likes shares'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETSocialNetPost commentStamp: 'T.A. 10/5/2014 18:07' prior: 0!
Social Net Post Model: represents a post on twitter or facebook.!

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/5/2014 19:04'!
hashtags
	^ hashtags! !

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/5/2014 19:05'!
hashtags: aCollection
	hashtags := aCollection! !

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/20/2014 01:18'!
likes
	^likes! !

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/20/2014 01:18'!
likes: aNumber
	likes := aNumber.! !

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/20/2014 01:18'!
shares
	^shares.! !

!SNETSocialNetPost methodsFor: 'accessing' stamp: 'T.A. 10/20/2014 01:19'!
shares: aNumber
	shares := aNumber.! !

Object subclass: #SNETFetcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFetcher commentStamp: 'T.A. 10/5/2014 18:43' prior: 0!
Interface for social network searching.!

SNETFetcher subclass: #SNETFacebookFetcher
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookFetcher commentStamp: 'T.A. 10/5/2014 19:07' prior: 0!
Fetcher implementation for facebook.!

!SNETFacebookFetcher methodsFor: 'helpers' stamp: 'T.A. 10/18/2014 00:51'!
accessToken
	"get facebook access token"
	|clientId clientSecret grantType url content jObject data token| 
	
	clientId := '743980072335668'.
	clientSecret := '0d3878c173d1f15ad5d158c0ef545107'.
	grantType := 'client_credentials'.
	
	url := self apiUrl, 'oauth/access_token?',
		'client_id=', clientId, '&client_secret=', clientSecret,
		'&grant_type=', grantType.

	content := self sendRequest: url.
	
	"Get the test users from app"
	url := self apiUrl, clientId, '/accounts/test-users?', content.
	
	content := self sendRequest: url.
	
	"Get the access_token of the first user"
	jObject := WebUtils jsonDecode: content readStream.
	data := jObject at: 'data'.
	token := (data first) at: 'access_token'.

^ 'access_token=', token.! !

!SNETFacebookFetcher methodsFor: 'helpers' stamp: 'T.A. 10/19/2014 21:39'!
apiUrl
	"facebook api base url"
	|baseUrl| 
	baseUrl := 'https://graph.facebook.com/v1.0/'.
^baseUrl.! !

!SNETFacebookFetcher methodsFor: 'helpers' stamp: 'T.A. 10/19/2014 22:24'!
fbPostFields
	"post fields for filtering"
	|fields| 
	fields := 'fields=caption,description,story,link,type,created_time,updated_time,likes.limit(1).summary(true)&limit=100'.

^fields.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'T.A. 10/20/2014 01:26'!
search: aTextToSearch
	"search posts on facebook"
		|token url search posts jPosts|

		token := self accessToken.
		search := '"', aTextToSearch, '"'.
		url := self apiUrl, 'nike', '/posts?', 'with=', search, '&', self fbPostFields, '&', token.
		posts := self sendRequest: url.

		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.		
		result := self toSocialNetPostList: jPosts.		

	^ result.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'LHC 10/19/2014 09:10'!
searchByHashtag: aTextToSearch
	"search posts on facebook by a hashtag"			
		|token url posts jPosts|

		token := self accessToken.
		url := self apiUrl, 'search?', 'q=%23', aTextToSearch, token.
		posts := self sendRequest: url.
		
		"TODO refatorar"
		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.

		Transcript show: jPosts.
		
		"TODO posts to goddata collection"
		
		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Facebook';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Facebook';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'LHC 10/19/2014 09:14'!
searchByHashtag: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on facebook by a hashtag posted between start date and end date"			
		|token url posts jPosts|

		token := self accessToken.
		url := self apiUrl, 'search?', 'q=%23', aTextToSearch, '&since=', aStartDate, '&until=', anEndDate, token.
		posts := self sendRequest: url.
		
		"TODO refatorar"
		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.

		Transcript show: jPosts.
		
		"TODO posts to goddata collection"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Facebook';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Facebook';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'LHC 10/19/2014 08:50'!
searchByProfile: aTextToSearch userId: anUserId
	"search user posts on facebook"			
		|token url posts jPosts|

		token := self accessToken.
		url := self apiUrl, anUserId, '/posts?', token.
		posts := self sendRequest: url.
		
		"TODO refatorar"
		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.

		Transcript show: jPosts.
		
		"TODO posts to goddata collection"
		
		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Facebook';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Facebook';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'LHC 10/19/2014 09:09'!
searchByProfile: aTextToSearch userId: anUserId startDate: aStartDate endDate: anEndDate
	"search user posts on facebook between a start date and an end date"			
		|token url posts jPosts|

		token := self accessToken.
		url := self apiUrl, anUserId, '/posts?', 'since=', aStartDate, '&until=', anEndDate, '&', token.
		posts := self sendRequest: url.
		
		"TODO refatorar"
		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.

		Transcript show: jPosts.
		
		"TODO posts to goddata collection"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Facebook';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Facebook';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETFacebookFetcher methodsFor: 'get' stamp: 'LHC 10/19/2014 09:09'!
searchByRangeDate: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on facebook posted between start date and end date"			
		|token url posts jPosts|

		token := self accessToken.
		url := self apiUrl, 'nike', '/posts?', 'since=', aStartDate, '&until=', anEndDate, '&', token.
		posts := self sendRequest: url.
		
		"TODO refatorar"
		jPosts := (WebUtils jsonDecode: posts readStream) at: 'data'.

		Transcript show: jPosts.
		
		"TODO posts to goddata collection"
		
		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Facebook';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Facebook';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETFacebookFetcher methodsFor: 'helpers' stamp: 'T.A. 10/18/2014 00:56'!
sendRequest: url
	"send http request to provider"
	|userAgent response|	
	
	userAgent := 'Mozilla/5.0'.

	response := [WebClient new httpGet: url do:[:req|
		req addHeader: 'User-Agent' value: userAgent.]
	]
	on: SqueakSSLCertificateError 
      do:[:ex| ex resume]. "ignore all certificate issues when using https/ssl" 

^response content.! !

!SNETFacebookFetcher methodsFor: 'helpers' stamp: 'T.A. 10/20/2014 01:55'!
toSocialNetPostList: aJSonObjectArray
	"converts json object array to social net post list"
	|result| 
	
	result := SortedCollection new.
	result := aJSonObjectArray collect: [:item |
		((SNETSocialNetPost new)
			content: (item at: 'caption' ifAbsent: [ '' ]);
			likes: (item at: 'likes' ifPresent: [ :like |
				"Obtem o numero de likes pelo summary"
				(like at: 'summary') at: 'total_count'.
			]);
			shares:  (item at: 'likes' ifPresent: [ :share |
				"Obtem o numero de shares pelo summary"
				(share at: 'summary') at: 'total_count'.
			]);
			origin: 'Facebook';
			timestamp: (Date readFrom:  (item at: 'created_time') readStream) asTimeStamp;
			yourself).
	].

^result.! !

!SNETFetcher methodsFor: 'helpers' stamp: 'T.A. 10/17/2014 00:56'!
accessToken
	"get authentication token"
^ self subclassResponsibility.
! !

!SNETFetcher methodsFor: 'helpers' stamp: 'T.A. 10/16/2014 23:47'!
apiUrl
	"api base url"
^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:38'!
search: aTextToSearch
	"search posts on a social network"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:38'!
searchByHashtag: aTextToSearch
	"search posts on a social network by a hashtag"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:48'!
searchByHashtag: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on a social network by a hashtag posted between start date and end date"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:50'!
searchByProfile: aTextToSearch userId: anUserId
	"search user posts on a social network"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:50'!
searchByProfile: aTextToSearch userId: anUserId startDate: aStartDate endDate: anEndDate
	"search user posts on a social network between a start date and an end date"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:56'!
searchByRangeDate: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on a social network between a start date and an end date"

	^ self subclassResponsibility.! !

!SNETFetcher methodsFor: 'helpers' stamp: 'T.A. 10/16/2014 23:40'!
sendRequest: url
	"sends a http request for the specific provider"
^ self subclassResponsibility.! !

SNETFetcher subclass: #SNETTwitterFetcher
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETTwitterFetcher commentStamp: 'T.A. 10/5/2014 19:07' prior: 0!
Fetcher implementation for twitter.!

!SNETTwitterFetcher methodsFor: 'helpers' stamp: 'T.A. 10/17/2014 00:58'!
accessToken
	"get twitter access token"
^nil.! !

!SNETTwitterFetcher methodsFor: 'helpers' stamp: 'T.A. 10/16/2014 23:50'!
apiUrl
	"twitter api base url"
	|baseUrl| 
	baseUrl := 'https://api.twitter.com/'.
^baseUrl.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:51'!
search: aTextToSearch
	"search posts on twitter"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((GODData new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((GODData new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).
	^ result.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:53'!
searchByHashtag: aTextToSearch
	"search posts on twitter by a hashtag"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:53'!
searchByHashtag: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on twitter by a hashtag posted between start date and end date"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:54'!
searchByProfile: aTextToSearch userId: anUserId
	"search user posts on twitter"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:55'!
searchByProfile: aTextToSearch userId: anUserId startDate: aStartDate endDate: anEndDate
	"search user posts on twitter between a start date and an end date"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETTwitterFetcher methodsFor: 'get' stamp: 'T.A. 10/5/2014 21:57'!
searchByRangeDate: aTextToSearch startDate: aStartDate endDate: anEndDate
	"search posts on twitter posted between start date and end date"

		result := OrderedCollection new.
		result sortBy: [:a :b | a timestamp < b timestamp].

		result add: ((SNETSocialNetPost new)
			content: 'Ola, tudo bem?';
			origin: 'Twitter';
			timestamp: Date today;
			yourself).

		result add: ((SNETSocialNetPost new)
			content: 'Post de ontem';
			origin: 'Twitter';
			timestamp: Date yesterday;
			yourself).

	^ result.! !

!SNETTwitterFetcher methodsFor: 'helpers' stamp: 'T.A. 10/17/2014 00:58'!
sendRequest: url
	"send http request to provider"

^nil.! !
